diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/test/wifi-emlsr-test.cc ns-3.44/src/wifi/test/wifi-emlsr-test.cc
--- ns-3.43/src/wifi/test/wifi-emlsr-test.cc	2024-10-09 16:41:10.136656800 -0700
+++ ns-3.44/src/wifi/test/wifi-emlsr-test.cc	2025-03-09 16:55:49.807372600 -0700
@@ -2911,62 +3131,78 @@
         m_staMacs[0]->GetEmlsrManager()->SetAuxPhyTxCapable(false);
         if (!m_nonEmlsrLink)
         {
-            // if there are two non-primary links, set MediumSyncDuration to zero so that the
+            // if there are two auxiliary links, set MediumSyncDuration to zero so that the
             // next UL QoS data frame is not protected also in case it is transmitted on the
-            // non-primary link other than the one on which the last frame exchange occurred
+            // auxiliary link other than the one on which the last frame exchange occurred
             m_staMacs[0]->GetEmlsrManager()->SetMediumSyncDuration(Seconds(0));
         }
 
-        // generate a very large backoff for the primary link, so that when an aux PHY gains a
+        // generate a very large backoff for the preferred link, so that when an aux PHY gains a
         // TXOP, it requests the main PHY to switch to its link to transmit the frames
         m_staMacs[0]->GetQosTxop(AC_BE)->StartBackoffNow(100, m_mainPhyId);
 
         // events to be scheduled at the end of the BlockAck response
         Simulator::Schedule(txDuration + NanoSeconds(1), [=, this]() {
-            // check that the main PHY switches to its primary link
+            // check that the main PHY switches to its preferred link
             auto mainPhy = m_staMacs[0]->GetDevice()->GetPhy(m_mainPhyId);
-            auto mainPhyLinkid = m_staMacs[0]->GetLinkForPhy(mainPhy);
 
             NS_TEST_EXPECT_MSG_EQ(mainPhy->IsStateSwitching(),
                                   true,
                                   "Main PHY is not switching at time "
                                       << Simulator::Now().As(Time::NS));
-            NS_TEST_ASSERT_MSG_EQ(mainPhyLinkid.has_value(),
-                                  true,
-                                  "Main PHY should be operating on a link");
-            NS_TEST_EXPECT_MSG_EQ(+mainPhyLinkid.value(),
-                                  +m_mainPhyId,
-                                  "Main PHY expected to operate on the primary link");
 
             // events to be scheduled when the first main PHY channel switch is completed
             Simulator::Schedule(mainPhy->GetChannelSwitchDelay(), [=, this]() {
+                // either the main PHY is operating on the preferred link or it is switching again
+                auto mainPhyLinkid = m_staMacs[0]->GetLinkForPhy(mainPhy);
+                if (mainPhyLinkid)
+                {
+                    NS_TEST_EXPECT_MSG_EQ(+mainPhyLinkid.value(),
+                                          +m_mainPhyId,
+                                          "Main PHY expected to operate on the preferred link");
+                }
+                else
+                {
+                    NS_TEST_EXPECT_MSG_EQ(
+                        mainPhy->IsStateSwitching(),
+                        true,
+                        "Main PHY is not operating on a link and it is not switching at time "
+                            << Simulator::Now().As(Time::NS));
+                }
+
                 auto acBe = m_staMacs[0]->GetQosTxop(AC_BE);
 
-                // find the min remaining backoff time on non-primary links for AC BE
+                // find the min remaining backoff time on auxiliary links for AC BE
                 auto minBackoff = Time::Max();
+                Time slot{0};
                 for (uint8_t id = 0; id < m_staMacs[0]->GetNLinks(); id++)
                 {
-                    // update backoff
-                    m_staMacs[0]->GetChannelAccessManager(id)->NeedBackoffUponAccess(acBe,
-                                                                                     true,
-                                                                                     true);
+                    if (!m_staMacs[0]->GetWifiPhy(id))
+                    {
+                        continue; // no PHY on this link
+                    }
+
                     if (auto backoff =
                             m_staMacs[0]->GetChannelAccessManager(id)->GetBackoffEndFor(acBe);
                         id != m_mainPhyId && m_staMacs[0]->IsEmlsrLink(id) && backoff < minBackoff)
                     {
                         minBackoff = backoff;
+                        slot = m_staMacs[0]->GetWifiPhy(id)->GetSlot();
                     }
                 }
 
                 // if the backoff on a link has expired before the end of the main PHY channel
-                // switch, the main PHY will be requested to switch again at the first slot
-                // boundary after the end of the channel switch. Otherwise, it will be requested
-                // to switch when the backoff expires.
-                auto expected2ndSwitchDelay = (minBackoff <= Simulator::Now())
-                                                  ? mainPhy->GetSlot()
-                                                  : (minBackoff - Simulator::Now());
+                // switch, the main PHY will be requested to switch again no later than the first
+                // slot boundary after the end of the channel switch. Otherwise, it will be
+                // requested to switch when the backoff expires or when the backoff counter reaches
+                // the configured number of slots
+                auto expected2ndSwitchDelay =
+                    (minBackoff <= Simulator::Now()) ? mainPhy->GetSlot()
+                    : m_nSlotsLeftAlert > 0
+                        ? Max(minBackoff - m_nSlotsLeftAlert * slot - Simulator::Now(), Time{0})
+                        : (minBackoff - Simulator::Now());
 
-                // check that the main PHY is requested to switch to a non-primary link after
+                // check that the main PHY is requested to switch to an auxiliary link after
                 // the expected delay
                 Simulator::Schedule(expected2ndSwitchDelay + NanoSeconds(1), [=, this]() {
                     NS_TEST_EXPECT_MSG_EQ(mainPhy->IsStateSwitching(),
@@ -2976,33 +3212,115 @@
                     NS_TEST_EXPECT_MSG_EQ(m_staMacs[0]->GetLinkForPhy(mainPhy).has_value(),
                                           false,
                                           "Main PHY should not be operating on a link because it "
-                                          "should be switching to a non-primary link");
+                                          "should be switching to an auxiliary link");
+                    // check that the appropriate trace info was received
+                    CheckMainPhyTraceInfo(0,
+                                          "UlTxopAuxPhyNotTxCapable",
+                                          std::nullopt,
+                                          0,
+                                          false,
+                                          false);
 
-                    // events to be scheduled when main PHY finishes switching to non-primary link
-                    Simulator::Schedule(mainPhy->GetDelayUntilIdle(), [=, this]() {
-                        auto nonPrimLinkId = m_staMacs[0]->GetLinkForPhy(mainPhy);
+                    const auto delayUntilIdle = mainPhy->GetDelayUntilIdle();
+                    auto startTimerDelay = delayUntilIdle;
+
+                    if (m_switchMainPhyBackDelayTimeout)
+                    {
+                        TimeValue switchMainPhyBackDelay;
+                        m_staMacs[0]->GetEmlsrManager()->GetAttribute("SwitchMainPhyBackDelay",
+                                                                      switchMainPhyBackDelay);
+
+                        // If nSlotsAlert is 0, the decision whether to start the switch back timer
+                        // is taken at the end of the PIFS period during which we perform CCA and
+                        // NAV check, which coincides with the end of the channel switch or is a
+                        // PIFS afterwards, depending on whether aux PHY CCA is used. Therefore,
+                        // before the end of the CCA and NAV check period we have to make the medium
+                        // busy on the link the main PHY is switching to. Given that we do not know
+                        // which link it is, we set the NAV on all links.
+                        // If nSlotsAlert > 0, the decision whether to start the switch back timer
+                        // is taken at the end of the channel switch and it is needed that the time
+                        // until the backoff end is at least a PIFS to start the switch back timer.
+                        auto endCcaNavCheckDelay = delayUntilIdle;
+
+                        for (uint8_t id = 0; id < m_staMacs[0]->GetNLinks(); ++id)
+                        {
+                            if (auto phy = m_staMacs[0]->GetWifiPhy(id))
+                            {
+                                if (!m_useAuxPhyCca && m_nSlotsLeftAlert == 0)
+                                {
+                                    endCcaNavCheckDelay =
+                                        Max(endCcaNavCheckDelay, delayUntilIdle + phy->GetPifs());
+                                }
+
+                                m_staMacs[0]->GetChannelAccessManager(id)->NotifyNavStartNow(
+                                    endCcaNavCheckDelay + TimeStep(1));
+                            }
+                        }
+                        startTimerDelay = endCcaNavCheckDelay;
 
-                        NS_TEST_ASSERT_MSG_EQ(nonPrimLinkId.has_value(),
+                        // when the SwitchMainPhyBackDelay timer starts, extend the NAV on the
+                        // aux PHY link on which the main PHY is operating by the timer duration
+                        // plus a channel switch delay, so that the timer expires and the main PHY
+                        // returns to the preferred link. If nSlotsAlert > 0, the timer duration is
+                        // extended by the expected channel access when the main PHY switch ends.
+                        Simulator::Schedule(startTimerDelay, [=, this]() {
+                            auto auxLinkId = m_staMacs[0]->GetLinkForPhy(mainPhy);
+                            NS_TEST_ASSERT_MSG_EQ(
+                                auxLinkId.has_value(),
+                                true,
+                                "Main PHY should be operating on a link before timer expires");
+                            auto timerDuration = switchMainPhyBackDelay.Get();
+                            if (m_nSlotsLeftAlert > 0)
+                            {
+                                timerDuration += (m_staMacs[0]
+                                                      ->GetChannelAccessManager(*auxLinkId)
+                                                      ->GetBackoffEndFor(acBe) -
+                                                  Simulator::Now());
+                            }
+                            m_staMacs[0]
+                                ->GetChannelAccessManager(*auxLinkId)
+                                ->NotifyNavStartNow(timerDuration +
+                                                    mainPhy->GetChannelSwitchDelay());
+
+                            // check that the SwitchMainPhyBackDelay timer expires and the main PHY
+                            // returns to the preferred link
+                            Simulator::Schedule(timerDuration + TimeStep(1), [=, this]() {
+                                CheckMainPhyTraceInfo(0,
+                                                      "TxopNotGainedOnAuxPhyLink",
+                                                      std::nullopt,
+                                                      m_mainPhyId,
+                                                      false);
+                            });
+                        });
+                    }
+
+                    // events to be scheduled when main PHY finishes switching to auxiliary link
+                    Simulator::Schedule(mainPhy->GetDelayUntilIdle(), [=, this]() {
+                        auto auxLinkId = m_staMacs[0]->GetLinkForPhy(mainPhy);
+                        NS_TEST_ASSERT_MSG_EQ(auxLinkId.has_value(),
                                               true,
                                               "Main PHY should have completed switching");
-                        // update backoff on the non-primary link on which main PHY is operating
-                        m_staMacs[0]
-                            ->GetChannelAccessManager(*nonPrimLinkId)
-                            ->NeedBackoffUponAccess(acBe, true, true);
+                        // update backoff on the auxiliary link on which main PHY is operating
+                        auto cam = m_staMacs[0]->GetChannelAccessManager(*auxLinkId);
+                        cam->NeedBackoffUponAccess(acBe, true, true);
+                        const auto usedAuxPhyCca =
+                            (m_useAuxPhyCca || m_auxPhyChannelWidth >= m_channelWidth) &&
+                            (m_nSlotsLeftAlert == 0 ||
+                             cam->GetBackoffEndFor(acBe) <= Simulator::Now());
+                        m_5thQosFrameExpWidth =
+                            usedAuxPhyCca ? m_auxPhyChannelWidth : m_channelWidth;
                         // record the time the transmission of the QoS data frames must have
                         // started: (a PIFS after) end of channel switch, if the backoff counter
-                        // on the non-primary link is null and UseAuxPhyCca is true (false); when
+                        // on the auxiliary link is null and UseAuxPhyCca is true (false); when
                         // the backoff expires, otherwise
-                        if (auto slots = acBe->GetBackoffSlots(*nonPrimLinkId); slots == 0)
+                        if (auto slots = acBe->GetBackoffSlots(*auxLinkId); slots == 0)
                         {
                             m_5thQosFrameTxTime =
                                 Simulator::Now() + (m_useAuxPhyCca ? Time{0} : mainPhy->GetPifs());
                         }
                         else
                         {
-                            m_5thQosFrameTxTime = m_staMacs[0]
-                                                      ->GetChannelAccessManager(*nonPrimLinkId)
-                                                      ->GetBackoffEndFor(acBe);
+                            m_5thQosFrameTxTime = cam->GetBackoffEndFor(acBe);
                         }
                     });
                 });
@@ -3012,39 +3330,11 @@
         // generate data packets for another UL data frame
         NS_LOG_INFO("Enqueuing two packets at the EMLSR client\n");
         m_staMacs[0]->GetDevice()->GetNode()->AddApplication(GetApplication(UPLINK, 0, 2, 1000));
-
         break;
     }
 }
 
 void
-EmlsrUlTxopTest::CheckInitialControlFrame(Ptr<const WifiMpdu> mpdu,
-                                          const WifiTxVector& txVector,
-                                          uint8_t linkId)
-{
-    CtrlTriggerHeader trigger;
-    mpdu->GetPacket()->PeekHeader(trigger);
-    if (!trigger.IsMuRts())
-    {
-        return;
-    }
-
-    if (linkId != m_mainPhyId && linkId != m_nonEmlsrLink)
-    {
-        // this is an ICF sent on an aux PHY link to start a DL TXOP. Given that aux PHYs do not
-        // switch channel, they are put in sleep mode while the main PHY is operating on their link
-        auto auxPhy = m_staMacs[0]->GetWifiPhy(linkId);
-        auto txDuration =
-            WifiPhy::CalculateTxDuration(mpdu->GetSize(), txVector, auxPhy->GetPhyBand());
-        Simulator::Schedule(txDuration + NanoSeconds(1), [=, this]() {
-            NS_TEST_EXPECT_MSG_EQ(auxPhy->IsStateSleep(),
-                                  true,
-                                  "Aux PHY on link " << +linkId << " not in sleep mode");
-        });
-    }
-}
-
-void
 EmlsrUlTxopTest::CheckRtsFrames(Ptr<const WifiMpdu> mpdu,
                                 const WifiTxVector& txVector,
                                 uint8_t linkId)
@@ -3096,47 +3386,62 @@
     auto txDuration = WifiPhy::CalculateTxDuration(mpdu->GetSize(),
                                                    txVector,
                                                    m_apMac->GetWifiPhy(linkId)->GetPhyBand());
+    const auto doCorruptCts = m_corruptCts.has_value() && *m_corruptCts;
 
-    if (linkId != m_mainPhyId && linkId != m_nonEmlsrLink &&
+    if (linkId != m_staMacs[0]->GetLinkForPhy(m_mainPhyId) && linkId != m_nonEmlsrLink &&
         mpdu->GetHeader().GetAddr1() == m_staMacs[0]->GetFrameExchangeManager(linkId)->GetAddress())
     {
         // this is a CTS sent to an aux PHY starting an UL TXOP. Given that aux PHYs do not
         // switch channel, they are put in sleep mode when the main PHY starts operating on their
         // link, which coincides with the end of CTS plus two propagation delays
-        auto auxPhy = m_staMacs[0]->GetWifiPhy(linkId);
+        const auto auxPhy = m_staMacs[0]->GetWifiPhy(linkId);
+        const auto mainPhy = m_staMacs[0]->GetDevice()->GetPhy(m_mainPhyId);
         Simulator::Schedule(txDuration, [=, this]() {
+            // when CTS ends, the main PHY is still switching and the aux PHY is not yet sleeping
+            NS_TEST_EXPECT_MSG_EQ(mainPhy->IsStateSwitching(),
+                                  true,
+                                  "Expecting the main PHY to be switching link");
             NS_TEST_EXPECT_MSG_EQ(auxPhy->IsStateSleep(),
                                   false,
                                   "Aux PHY on link " << +linkId << " already in sleep mode");
+            // when CTS is sent, the main PHY may have already started switching, thus we may not
+            // know which link the main PHY is moving from
+            CheckMainPhyTraceInfo(0, "UlTxopRtsSentByAuxPhy", std::nullopt, linkId, false);
         });
-        // if the CTS is corrupted, the TXOP ends and the aux PHY is not put to sleep
-        auto isStateSleep = !(m_corruptCts.has_value() && *m_corruptCts);
-
         Simulator::Schedule(
-            txDuration + MicroSeconds(2 * MAX_PROPAGATION_DELAY_USEC) + NanoSeconds(1),
+            txDuration + MicroSeconds(2 * MAX_PROPAGATION_DELAY_USEC) + TimeStep(1),
             [=, this]() {
-                NS_TEST_EXPECT_MSG_EQ(auxPhy->IsStateSleep(),
-                                      isStateSleep,
-                                      "Aux PHY on link " << +linkId
-                                                         << (isStateSleep ? " not yet" : " already")
-                                                         << " in sleep mode");
+                // aux PHYs are put to sleep if and only if CTS is not corrupted
+                // (causing the end of the TXOP)
+                CheckAuxPhysSleepMode(m_staMacs[0], !doCorruptCts);
+                // if CTS is corrupted, TXOP ends and the main PHY switches back
+                // to the preferred link
+                if (doCorruptCts)
+                {
+                    // check the traced remaining time before calling CheckMainPhyTraceInfo
+                    if (const auto traceInfoIt = m_traceInfo.find(0);
+                        traceInfoIt != m_traceInfo.cend() &&
+                        traceInfoIt->second->GetName() == "TxopEnded")
+                    {
+                        const auto& traceInfo =
+                            static_cast<const EmlsrTxopEndedTrace&>(*traceInfoIt->second);
+                        NS_TEST_EXPECT_MSG_GT(traceInfo.remTime,
+                                              Time{0},
+                                              "Expected non-zero remaining time because main PHY "
+                                              "was switching when TXOP ended");
+                    }
+
+                    CheckMainPhyTraceInfo(0, "TxopEnded", linkId, m_mainPhyId);
+                }
             });
     }
 
-    if (m_corruptCts.has_value() && *m_corruptCts)
+    if (doCorruptCts)
     {
         // corrupt reception at EMLSR client
         NS_LOG_INFO("CORRUPTED");
         m_errorModel->SetList({mpdu->GetPacket()->GetUid()});
         m_corruptCts = false;
-
-        // main PHY is about to complete channel switch when CTS ends
-        Simulator::Schedule(txDuration, [=, this]() {
-            const auto mainPhy = m_staMacs[0]->GetDevice()->GetPhy(m_mainPhyId);
-            NS_TEST_EXPECT_MSG_EQ(mainPhy->IsStateSwitching(),
-                                  true,
-                                  "Expecting the main PHY to be switching link");
-        });
     }
 }
 
@@ -3245,15 +3550,15 @@
      * For both scenarios, after the last frame exchange on the main PHY link, we have the
      * following frame exchanges on an EMLSR link where an aux PHY is operating on. After the
      * first frame exchange, aux PHYs are configured as non-TX capable. Note that the two frame
-     * exchanges may occur on distinct non-primary EMLSR links.
+     * exchanges may occur on distinct auxiliary EMLSR links.
      *
-     *                                             | main PHY || main PHY  |
-     *  [ link ]   ┌───┐         ┌───┐         ┌──┐| switches ||switches to|             ┌──┐
-     *  [0 or 2]   │CTS│         │CTS│         │BA│|to primary||non-primary|PIFS|        │BA│
-     *  ──────┬───┬┴───X────┬───┬┴───┴┬───┬───┬┴──┴─────────────────────────────┬───┬───┬┴──┴────
-     *        │RTS│         │RTS│     │QoS│QoS│                                 │QoS│QoS│
-     *        └───┘         └───┘     │ X │ Y │                                 │ Z │ W │
-     *                                └───┴───┘                                 └───┴───┘
+     *                                             | main PHY  || main PHY  |
+     *  [ link ]   ┌───┐         ┌───┐         ┌──┐|switches to||switches to|             ┌──┐
+     *  [0 or 2]   │CTS│         │CTS│         │BA│| preferred ||auxiliary  |PIFS|        │BA│
+     *  ──────┬───┬┴───X────┬───┬┴───┴┬───┬───┬┴──┴──────────────────────────────┬───┬───┬┴──┴───
+     *        │RTS│         │RTS│     │QoS│QoS│                                  │QoS│QoS│
+     *        └───┘         └───┘     │ X │ Y │                                  │ Z │ W │
+     *                                └───┴───┘                                  └───┴───┘
      * For all EMLSR links scenario, X=10, Y=11, Z=12, W=13
      * For the scenario with a non-EMLSR link, X=12, Y=13, Z=14, W=15
      */
@@ -3449,11 +3754,47 @@
                           m_auxPhyChannelWidth,
                           "Fourth data frame not transmitted on the same width as RTS");
 
+    auto fourthLinkId = psduIt->linkId;
+
     psduIt++;
     jumpToQosDataOrMuRts();
 
-    // the fifth QoS data frame is transmitted by the main PHY on a non-primary link because
-    // the aux PHY is not TX capable. The QoS data frame is not protected by RTS
+    NS_TEST_ASSERT_MSG_EQ((psduIt != m_txPsdus.cend()), true, "Expected more frames");
+    // Do not check the start transmission time if a backoff is generated even when no
+    // transmission is done (if the backoff expires while the main PHY is switching, a new
+    // backoff is generated and, before this backoff expires, the main PHY may be requested
+    // to switch to another auxiliary link; this may happen multiple times...)
+    if (!m_genBackoffIfTxopWithoutTx && !m_switchMainPhyBackDelayTimeout)
+    {
+        NS_TEST_EXPECT_MSG_LT_OR_EQ(psduIt->startTx,
+                                    m_5thQosFrameTxTime,
+                                    "Fifth data frame transmitted too late");
+    }
+
+    // the fifth QoS data frame is transmitted by the main PHY on an auxiliary link because
+    // the aux PHY is not TX capable. The QoS data frame is protected by RTS if it is transmitted
+    // on a different link than the previous one (because the MediumSyncDelay timer is running)
+    if (psduIt->linkId != fourthLinkId)
+    {
+        // RTS
+        NS_TEST_EXPECT_MSG_EQ(psduIt->psduMap.cbegin()->second->GetHeader(0).IsRts(),
+                              true,
+                              "Fifth QoS data frame should be transmitted with protection");
+        NS_TEST_EXPECT_MSG_EQ(
+            +psduIt->phyId,
+            +m_mainPhyId,
+            "RTS before fifth QoS data frame should be transmitted by the main PHY");
+        psduIt++;
+        // CTS
+        NS_TEST_ASSERT_MSG_EQ((psduIt != m_txPsdus.cend()),
+                              true,
+                              "CTS before fifth QoS data frame has not been transmitted");
+        NS_TEST_EXPECT_MSG_EQ(psduIt->psduMap.cbegin()->second->GetHeader(0).IsCts(),
+                              true,
+                              "CTS before fifth QoS data frame has not been transmitted");
+        psduIt++;
+    }
+
     // QoS Data
     NS_TEST_ASSERT_MSG_EQ((psduIt != m_txPsdus.cend()),
                           true,
